************************************************************************
* This is the FORTRAN module (nc_br_1212_42) to calculate EW Born
* cross section and soft photon Bremsstrahlung
* for the el^+ + el^- -> Z + H process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_br_12_12__02_04 (qs,ts,us,born,soft,hard)
        implicit none!
        include 's2n_declare.h'

        integer iborn_
        real*8 sq,af,vf,sqrtlszh,l2
        complex*16 propzs,propizs,propzsc
        real*8 softisr,softfsr,softifi

        soft = 0d0
        hard = 0d0
        softisr = 0d0
        softfsr = 0d0
        softifi = 0d0

        cmz2 = mz2

        s = -qs
        t = -ts
        u = -us
        sq = dsqrt(s)

        iborn_ = iborn
        iborn  = 1
        call nc_si_12_12__02_04(s,t,u,born)
        iborn  = iborn_
        if (born.ne.born) print *,'Born NAN!!!',s,t,u

        if (iborn.eq.1) return

        l2 = log(s/mel**2)

        softisr =
     &   +born/pi*alpha*qel**2*(-1d0/2)
     &   +born/pi*alpha*qel**2*(l2-1)*(3d0/2)
     &   +log(2*omega/sq)*born/pi*alpha*qel**2*(l2-1)*(2)
     &   +ddilog(1d0)*born/pi*alpha*qel**2*(2)

        if (iqed.eq.1) then
          soft = softisr+softfsr+softifi
        elseif(iqed.eq.2) then
          soft = softisr
        elseif(iqed.eq.3) then
          soft = softifi
        elseif(iqed.eq.4) then
          soft = softfsr
        elseif(iqed.eq.5) then
          soft = softifi+softfsr
        elseif(iqed.eq.6) then
          soft = softisr+softifi
        endif

        soft = soft*cfprime
        if (soft.ne.soft) print *,'Soft NAN!!!',s,t,u

        return
      end
