************************************************************************
* sanc_cc_v1.70 package.
************************************************************************
* File (nc_ff_12_12__12_12.F) is created on Вт ноя 14 04:10:27 MSK 2017.
************************************************************************
* This is the FORTRAN module (nc_ff_12_12__12_12) to calculate 1-loop EW
* form factors for the Bhabha (el^+ + el^- -> el^+ + el^-) process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2017.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_12_12__12_12 (qs,ts,us)
        implicit none!
#include "s2n_declare.h"

        complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
        complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
        complex*16 ff_ew_qd,ff_qed_gg
        real*8 isr,ifi,fsr

        real*8 a0fel,a0fw,a0fz,a0fh
        real*8 lnlaelm
        complex*16 b0fqszc,b0fqscc,b0ftscc,b0fuscc,b0fqsww,b0fqszz,b0fqsz
     &   h
        complex*16 c0elelqszelc,c0irelelqs,c0elelqscelc,c0irelelts,c0irel
     &   elus,c0celtsczel,c0celusczel,c0ccqswcw,c0ccqszcz,c0ccqscwc,c0ccqs
     &   czc,c0cctscwc,c0cctsczc,c0ccusczc
        complex*16 d0ccccqstswcwc,d0ccccqstszczc,d0ccccqsuszczc
        complex*16 jaaqstselel,jaaqsuselel,javqstselelz,javqsuselelz
        real*8 pxx2zqsc
        complex*16 propzqs,propizqs
        real*8 der,errdersta,errdersys,deg,errdegsta,errdegsys
        complex*16 w(98)

        common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
        common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     &   zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
        common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer
        common/unipro_fer_d/piggferl,piggferh,piggfert
        common/unibos_fer_d/za1ferl,za1ferh,za1fert

        common/keys/igzm2

        cmz2 = mz2
        if (igzm2.eq.0) then
          cmz2 = rzm2
        endif

        isr = 1d0
        ifi = 1d0
        fsr = 1d0


        propizqs = (cmz2+qs)
        propzqs = 1d0/propizqs
        a0fel = log(relm2/thmu2) - 1d0
        a0fw = log(rwm2/thmu2) - 1d0
        a0fz = log(rzm2/thmu2) - 1d0
        a0fh = log(rhm2/thmu2) - 1d0
        lnlaelm = log(relm2/tlmu2)
        b0fqszc = b0f(qs,thmu2,zm2,cm2)
        b0fqscc = b0f(qs,thmu2,cm2,cm2)
        b0ftscc = b0f(ts,thmu2,cm2,cm2)
        b0fuscc = b0f(us,thmu2,cm2,cm2)
        b0fqsww = b0f(qs,thmu2,wm2,wm2)
        b0fqszz = b0f(qs,thmu2,zm2,zm2)
        b0fqszh = b0f(qs,thmu2,zm2,hm2)
        c0elelqszelc = c01(-relm2,-relm2,qs,zm2,elm2,cm2)
        c0irelelqs = c0ir(tlmu2,elm2,elm2,qs)
        c0elelqscelc = c01(-relm2,-relm2,qs,cm2,elm2,cm2)
        c0irelelts = c0ir(tlmu2,elm2,elm2,ts)
        c0irelelus = c0ir(tlmu2,elm2,elm2,us)
        c0celtsczel = c01(0d0,-relm2,ts,cm2,zm2,elm2)
        c0celusczel = c01(0d0,-relm2,us,cm2,zm2,elm2)
        c0ccqswcw = c01(0d0,0d0,qs,wm2,cm2,wm2)
        c0ccqszcz = c01(0d0,0d0,qs,zm2,cm2,zm2)
        c0ccqscwc = c01(0d0,0d0,qs,cm2,wm2,cm2)
        c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
        c0cctscwc = c01(0d0,0d0,ts,cm2,wm2,cm2)
        c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
        c0ccusczc = c01(0d0,0d0,us,cm2,zm2,cm2)
        d0ccccqstswcwc = d040(qs,ts,wm2,cm2)
        d0ccccqstszczc = d040(qs,ts,zm2,cm2)
        d0ccccqsuszczc = d040(qs,us,zm2,cm2)
        jaaqstselel = jaa(qs,ts,elm2,elm2)
        jaaqsuselel = jaa(qs,us,elm2,elm2)
        javqstselelz = jav(qs,ts,elm2,elm2,zm2)
        javqsuselelz = jav(qs,us,elm2,elm2,zm2)
        pxx2zqsc = (2*mz**2)+(qs)

        if (ifgg.le.2) then
          ff_qed_gg =
     &       -za1fer+stw**2*piggfer
        else
          call dhadr5x19(sign(sqrt(abs(qs)),-qs),0d0,der,errdersta,errdersys,deg,errdegsta,errdegsys)
          ff_qed_gg =
     &       -za1ferl+stw**2*piggferl-za1fert+stw**2*piggfert+der/alpha*4d0*pi*stw2
        endif

        w(1)=real(propizqs)
        w(2)=Ts**(-1)
        w(3)=Us**(-1)
        w(4)=stw**(-1)
        w(5)=rwz**(-1)
        w(6)=Qs**(-1)
        w(7)=mw**(-1)
        w(8)=ctw**(-1)
        w(9)=real(propzqs)
        w(10)=rhw**(-1)
        w(11)=stw**2
        w(12)=w(11)**2
        w(13)=8.D0*w(12)
        w(14)=w(13) + 1.D0
        w(15)=w(11)*z_ex
        w(16)=w(14)*w(15)
        w(17)=4.D0*w(12)
        w(18)=qel*z_ex
        w(19)=w(17)*w(18)
        w(16)=w(16) + w(19)
        w(20)=w(16)*javqstselelz
        w(21)=gamma_ex*CFScheme
        w(22)=w(21)*ctw**2
        w(23)=w(22)*jaaqstselel
        w(24)=w(23)*w(17)
        w(24)=w(24) + w(20)
        w(25)=w(16)*c0celtsczel
        w(26)=2.D0*w(25) + w(24)
        w(26)=w(3)*w(26)
        w(27)=w(16)*c0elelqszelc
        w(25)=w(27) - w(25)
        w(20)= - 2.D0*w(25) + w(20)
        w(27)=w(3)**2
        w(28)=mz**2
        w(20)=w(20)*w(27)*w(28)
        w(29)=w(22)*c0elelqscelc
        w(30)=w(17)*w(29)
        w(25)=w(30) + w(25)
        w(24)=2.D0*w(25) - w(24)
        w(25)=w(27)*Ts
        w(24)=w(24)*w(25)
        w(20)=w(24) + w(26) + w(20)
        w(20)=Ts*w(20)
        w(24)= - b0fqszc*w(16)
        w(26)=w(22)*w(17)
        w(30)=w(26) + w(16)
        w(30)=b0ftscc*w(30)
        w(26)= - b0fqscc*w(26)
        w(24)=w(30) + w(24) + w(26)
        w(24)=w(3)*w(24)
        w(18)=w(18)*w(12)
        w(26)= - 1.D0 - 16.D0*w(12)
        w(26)=w(26)*w(15)
        w(26)=w(26) - 8.D0*w(18)
        w(26)=c0elelqszelc*w(26)
        w(30)=w(28)*c0elelqszelc
        w(31)=w(30)*w(3)
        w(16)= - w(16)*w(31)
        w(32)= - w(13)*w(29)
        w(16)=w(16) + w(24) + w(26) + w(32)
        w(16)=2.D0*w(16) + w(20)
        w(16)=w(1)*w(16)
        w(20)=w(15)*c0irelelts
        w(24)=w(15)*c0celtsczel
        w(26)=w(15)*javqstselelz
        w(20)= - w(26) + w(20) - w(24)
        w(32)=w(20)*Ts
        w(33)=c0celusczel - c0irelelus
        w(33)=w(15)*w(33)
        w(34)=w(33)*Us
        w(32)=w(34) + w(32)
        w(34)=2.D0*z_ex
        w(35)=w(34)*w(11)
        w(36)=javqsuselelz*Us
        w(37)=w(36)*w(35)
        w(32)=w(37) + 2.D0*w(32)
        w(16)=w(16) - w(32)
        w(37)=2.D0*IFI
        w(16)=w(16)*w(37)
        w(38)=stw**6
        w(34)=w(34)*w(38)
        w(34)=w(34) + w(18)
        w(39)=w(34)*c0elelqszelc
        w(40)=w(34)*c0celusczel
        w(39)=w(39) - w(40)
        w(41)=2.D0*w(28)
        w(42)= - w(39)*w(41)
        w(43)=w(12)*w(29)
        w(39)=w(43) + w(39)
        w(43)=w(22)*w(12)
        w(44)=w(43)*jaaqsuselel
        w(39)=2.D0*w(39) - w(44)
        w(39)=Us*w(39)
        w(39)=w(42) + w(39)
        w(42)=w(1)*Us
        w(39)=w(39)*w(42)
        w(45)=w(28) - Us
        w(46)=w(42)*javqsuselelz
        w(45)=w(45)*w(46)
        w(47)=w(34)*w(45)
        w(39)=w(39) + w(47)
        w(47)=w(2)*IFI
        w(39)=w(39)*w(47)
        w(30)= - b0fuscc + w(30) + b0fqszc
        w(48)= - w(34)*w(30)
        w(49)= - b0fqscc + b0fuscc
        w(43)=w(43)*w(49)
        w(43)=w(48) + w(43)
        w(40)=2.D0*w(40) + w(44)
        w(40)=Us*w(40)
        w(40)=2.D0*w(43) + w(40)
        w(40)=w(1)*w(40)
        w(34)=w(46)*w(34)
        w(34)=w(40) + w(34)
        w(34)=IFI*w(34)
        w(34)=w(34) + w(39)
        w(34)=w(2)*w(34)
        w(39)=FSR + ISR
        w(40)=w(15)*w(39)
        w(43)=2.D0*w(40)
        w(44)=c0irelelqs*Qs
        w(44)=w(44) - lnlaelm
        w(43)=w(43)*w(44)
        w(44)=3.D0*w(40)
        w(48)=a0fel + b0fqscc
        w(44)=w(44)*w(48)
        w(40)=w(40) + w(44) + w(43)
        w(16)=8.D0*w(34) + w(16) - w(40)
        w(34)=mw**2
        w(43)=w(34)*d0ccccqstswcwc
        w(44)=w(43) + c0ccqswcw
        w(49)=w(44) - c0cctscwc
        w(50)=w(49)*w(3)
        w(51)=4.D0*w(34)
        w(52)= - w(51)*w(50)
        w(52)=w(52) + c0cctscwc + w(44)
        w(52)=w(3)*w(52)
        w(53)=2.D0*w(43)
        w(54)=w(53) - c0cctscwc
        w(55)=c0ccqswcw + w(54)
        w(55)=w(55)*w(27)
        w(56)= - d0ccccqstswcwc*w(25)
        w(55)=2.D0*w(55) + w(56)
        w(55)=Ts*w(55)
        w(52)=w(52) + w(55)
        w(52)=Ts*w(52)
        w(55)=4.D0*c0ccqswcw
        w(54)= - w(55) - w(54)
        w(54)=w(54)*w(34)
        w(54)=b0ftscc + w(54) - 2.D0*b0fqsww - a0fw
        w(56)=2.D0*w(3)
        w(54)=w(54)*w(56)
        w(57)=w(7)**2
        w(58)=w(57)*b0fqsww
        w(58)=5.D0/3.D0*w(58)
        w(59)=w(43) + c0cctscwc
        w(60)=5.D0*c0ccqswcw
        w(61)=Us*d0ccccqstswcwc
        w(52)=w(52) + w(61) + w(58) + w(54) + w(60) - w(59)
        w(52)=w(1)*w(52)
        w(54)=w(43) - c0cctscwc
        w(60)=w(60) + w(54)
        w(61)=3.D0*c0ccqswcw
        w(62)= - w(61) + 2.D0*c0cctscwc
        w(53)=w(62) - w(53)
        w(53)=w(53)*w(34)
        w(63)=a0fw + b0fqsww
        w(53)=w(53) - w(63)
        w(64)=2.D0*w(6)
        w(65)=w(53)*w(64)
        w(66)= - w(65) + w(60)
        w(66)=Us*w(66)
        w(67)=2.D0*c0ccqswcw
        w(54)=w(54) + w(67)
        w(54)=w(54)*w(34)
        w(54)=w(54) + w(63)
        w(68)= - w(3)*w(54)
        w(53)= - w(6)*w(53)
        w(53)=w(53) + w(68) - c0cctscwc + w(67)
        w(68)=Ts*w(3)
        w(49)=w(49)*w(68)
        w(49)=2.D0*w(53) + w(49)
        w(49)=Ts*w(49)
        w(53)=w(63) + 1.D0
        w(69)=w(53)*w(51)
        w(70)=w(69)*w(9)
        w(71)=3.D0*c0cctscwc
        w(72)=3.D0*w(43) - w(71) - c0ccqswcw
        w(72)=w(72)*w(34)
        w(73)=c0ccqswcw*w(34)
        w(73)=w(73) + w(63)
        w(73)=w(6)*w(73)*w(51)
        w(74)=b0fqscc + a0fz
        w(75)=18.D0*w(74)
        w(76)=2.D0*a0fw
        w(49)=w(52) + w(49) - w(70) + w(66) + w(73) + w(72) + w(76) + 4.D0
     &    + 5.D0*b0fqsww - w(75)
        w(49)=rwz*w(49)
        w(52)=w(17) + 3.D0
        w(66)=2.D0*w(12)
        w(72)=w(52)*w(66)
        w(73)=w(17) + 1.D0
        w(77)=w(73)*w(11)
        w(78)=2.D0*qel
        w(79)=w(77)*w(78)
        w(72)=w(79) + w(72) + 1.D0/4.D0
        w(72)=w(72)*d0ccccqstszczc
        w(79)=w(52)*w(17)
        w(80)=4.D0*qel
        w(77)=w(77)*w(80)
        w(77)=w(79) + w(77) + 1.D0/2.D0
        w(79)=c0cctsczc - c0ccqszcz
        w(81)=w(79)*w(3)
        w(82)=w(77)*w(81)
        w(82)= - 3.D0*w(72) + w(82)
        w(82)=w(3)*w(82)
        w(83)=w(27)*pxx2zqsc
        w(72)= - w(83)*w(72)
        w(72)=w(82) + w(72)
        w(72)=pxx2zqsc*w(72)
        w(82)=w(73)*w(12)
        w(84)=w(80)*w(38)
        w(82)=w(82) + w(84)
        w(85)=w(82)*d0ccccqsuszczc
        w(86)=w(52)*w(13)
        w(87)=w(11)*qel
        w(73)=w(73)*w(87)
        w(86)=w(86) + 1.D0 + 8.D0*w(73)
        w(81)=w(86)*w(81)
        w(52)=w(52)*w(12)
        w(52)=w(73) + w(52) + 1.D0/8.D0
        w(52)=w(52)*d0ccccqstszczc
        w(86)= - w(68)*w(52)
        w(80)=w(80)*w(11)
        w(13)= - w(80) - 1.D0/2.D0 - w(13)
        w(13)=d0ccccqstszczc*w(13)
        w(13)=w(86) + w(72) + w(81) - w(85) + w(13)
        w(13)=Ts*w(13)
        w(72)=w(3)*c0ccqszcz
        w(81)= - w(77)*w(72)
        w(86)=pxx2zqsc*w(3)
        w(88)= - w(52)*w(86)
        w(81)=w(88) - 2.D0*w(85) + w(81)
        w(81)=pxx2zqsc*w(81)
        w(88)=3.D0 - w(17)
        w(88)=w(88)*w(66)
        w(89)=1.D0 - w(66)
        w(80)=w(89)*w(80)
        w(80)=w(80) + 1.D0/2.D0 + w(88)
        w(80)=d0ccccqsuszczc*w(80)
        w(52)=w(80) + w(52)
        w(52)=Us*w(52)
        w(80)=b0fqszz - b0ftscc
        w(88)=w(80)*w(3)
        w(89)=w(28)*d0ccccqstszczc
        w(90)= - w(89) - w(88)
        w(77)=w(77)*w(90)
        w(14)=w(14)*w(87)
        w(90)= - 1.D0 - w(66)
        w(90)=w(90)*w(12)
        w(90)= - 8.D0*w(14) - 1.D0 + 32.D0*w(90)
        w(90)=c0ccqszcz*w(90)
        w(13)=w(13) + w(52) + w(81) + w(90) + w(77)
        w(52)=w(8)**2
        w(77)=w(52)*w(1)
        w(13)=w(13)*w(77)
        w(81)=w(82)*c0ccqszcz
        w(90)=pxx2zqsc*d0ccccqsuszczc
        w(91)=w(90)*w(82)
        w(92)= - 4.D0*w(81) - w(91)
        w(92)=pxx2zqsc*w(92)
        w(93)=w(82)*c0ccusczc
        w(81)=w(93) - w(81)
        w(93)=4.D0*w(81) - 3.D0*w(91)
        w(85)= - Us*w(85)
        w(85)=2.D0*w(93) + w(85)
        w(85)=Us*w(85)
        w(93)=b0fqszz - b0fuscc
        w(82)= - w(82)*w(93)
        w(82)=w(85) + 4.D0*w(82) + w(92)
        w(82)=w(82)*w(77)
        w(81)=2.D0*w(81) - w(91)
        w(52)=pxx2zqsc*w(52)*w(42)
        w(81)=w(81)*w(52)
        w(85)=Us**2
        w(85)=w(85) + w(42)
        w(71)=w(71) + w(44)
        w(71)=w(71)*w(34)
        w(71)=w(71) - 4.D0*a0fw
        w(91)= - w(71) + 4.D0*b0ftscc
        w(85)=rwz*w(91)*w(85)
        w(71)=w(71)*w(34)
        w(91)= - b0ftscc*w(51)
        w(71)=w(71) + w(91)
        w(71)=Us*w(71)
        w(71)=w(85) + w(71) + 2.D0*w(81)
        w(71)=w(2)*w(71)
        w(60)=w(60)*w(34)
        w(44)=w(44)*Us
        w(60)=2.D0*w(44) + w(60) + 4.D0*w(63)
        w(81)= - w(34)*w(60)
        w(60)=w(1)*w(60)
        w(85)=c0ccqswcw - c0cctscwc
        w(85)=w(85)*w(34)
        w(76)=b0ftscc + w(85) + b0fqsww + w(76)
        w(44)=2.D0*w(76) + w(44)
        w(44)=Us*w(44)
        w(44)=2.D0*w(44) + w(60)
        w(44)=rwz*w(44)
        w(44)=w(71) + w(44) + w(82) + w(81)
        w(44)=w(2)*w(44)
        w(60)=1.D0 + 3.D0/2.D0*a0fz
        w(60)=w(5)*w(10)*w(60)
        w(71)=1.D0/12.D0*b0fqsww
        w(60)=w(60) + b0fqszh + w(71) - 1.D0/18.D0 + 1.D0/6.D0*a0fz
        w(60)=w(60)*w(5)
        w(76)=a0fh - 1.D0/3.D0
        w(76)= - 1.D0/12.D0*a0fz - 1.D0/3.D0*b0fqszh + 1.D0/2.D0*w(76)
        w(76)=w(76)*rhw
        w(81)=1.D0/6.D0 + 3.D0*w(10)
        w(81)=w(81)*a0fw
        w(82)=4.D0/3.D0*b0fqsww
        w(60)=w(60) + w(76) + w(81) + 2.D0*w(10) + w(82) - 5.D0/9.D0
        w(60)=w(60)*w(5)
        w(76)=17.D0*b0fqsww
        w(81)=b0fqszh + a0fh
        w(81)=w(81)*rhw**2
        w(85)=w(76) - 1.D0/4.D0*w(81) + 8.D0 + 8.D0*a0fw
        w(91)=w(5)*ZmzZzBos
        w(60)= - w(91) + w(60) - 1.D0/3.D0*w(85)
        w(60)=w(9)*w(34)*w(60)
        w(60)=w(60) + calDzFer - Za1Fer
        w(85)= - Za1Bos + w(60)
        w(91)=a0fz + a0fh
        w(91)=b0fqszh + 1.D0/2.D0*w(91)
        w(91)=w(91)*rhw
        w(92)=1.D0/6.D0*w(91)
        w(94)= - b0fqszh + 83.D0*a0fz
        w(94)=1.D0/12.D0*w(94) + 7.D0*b0fqscc
        w(94)=w(5)*w(94)
        w(75)=w(94) + w(92) - w(75)
        w(75)=w(5)*w(75)
        w(94)=w(5)*c0ccqsczc
        w(95)=7.D0*w(94)
        w(96)= - w(95) + 18.D0*c0ccqsczc
        w(96)=w(96)*w(5)
        w(97)=12.D0*c0ccqsczc
        w(98)= - w(97) + w(96)
        w(98)=w(5)*w(98)
        w(62)=c0ccqscwc - w(62)
        w(43)=4.D0*w(43) + 2.D0*w(62) + w(98)
        w(43)=w(43)*w(34)
        w(62)=1.D0/12.D0*w(81)
        w(81)=6.D0*a0fz
        w(98)=5.D0*b0fqscc + b0fqsww + w(81)
        w(43)=w(43) + w(75) + 2.D0*w(98) - w(62)
        w(43)=w(6)*w(43)
        w(75)= - c0ccqscwc + 6.D0*c0ccqsczc
        w(75)=2.D0*w(75)
        w(96)=w(75) - w(96)
        w(54)=w(54)*w(56)
        w(43)=w(43) + w(54) + 2.D0*w(96)
        w(43)=w(34)*w(43)
        w(54)=w(7)**4
        w(96)= - w(54)*w(71)
        w(96)=d0ccccqstswcwc + w(96)
        w(96)=w(1)*w(96)
        w(58)=w(96) - w(97) - w(58)
        w(58)=rwz*w(58)
        w(54)=Qs*rwz*w(54)
        w(54)=w(54) + w(57)
        w(54)=w(71)*w(54)
        w(57)=9.D0*c0ccqsczc + c0ccqscwc
        w(54)=w(58) + 2.D0*w(57) - w(95) + w(54)
        w(54)=Qs*w(54)
        w(57)=w(65) + w(59) - w(61)
        w(57)=w(6)*w(57)*w(34)
        w(58)= - Us*w(57)
        w(50)= - w(34)*w(50)
        w(50)=w(50) - w(57)
        w(50)=Ts*w(50)
        w(57)=DeltarhoBos + DeltarhoFer
        w(59)=w(4)**2
        w(61)=w(59) - 2.D0
        w(61)=w(61)*w(57)
        w(65)=b0fqsww + b0fqszh
        w(71)= - 67.D0/3.D0 - w(65)
        w(71)=1.D0/6.D0*w(71) - 21.D0*w(74)
        w(95)=1.D0/2.D0*w(5)
        w(71)=w(71)*w(95)
        w(13)=w(44) + w(54) + w(49) + w(13) + w(50) + w(58) + w(71) + 30.D
     &   0*b0fqscc + 3.D0*a0fw + 27.D0*a0fz - w(82) + 47.D0/9.D0 + w(43)
     &    + w(85) + w(61)
        w(43)=2.D0*w(18)
        w(44)=w(43)*c0celtsczel
        w(49)=w(18)*javqstselelz
        w(44)=w(44) + w(49)
        w(50)=w(22)*w(87)
        w(54)=w(50)*jaaqstselel
        w(44)=w(54) + 2.D0*w(44)
        w(44)=w(44)*w(3)
        w(58)=c0elelqszelc - c0celtsczel
        w(18)=w(18)*w(58)
        w(18)= - w(49) + 2.D0*w(18)
        w(49)=w(50)*c0elelqscelc
        w(58)=w(18) + w(49)
        w(54)= - w(54) + 2.D0*w(58)
        w(54)=w(54)*w(25)
        w(58)=w(41)*w(27)
        w(18)=w(58)*w(18)
        w(18)=w(44) + w(54) - w(18)
        w(18)=w(18)*Ts
        w(44)=w(50) + w(43)
        w(44)=w(44)*b0ftscc
        w(54)=w(43)*b0fqszc
        w(61)=w(50)*b0fqscc
        w(44)= - w(44) + w(54) + w(61)
        w(44)=w(44)*w(3)
        w(54)=w(11)*w(29)*w(78)
        w(19)=w(19) + w(15)
        w(19)=w(19)*c0elelqszelc
        w(71)=w(31)*w(43)
        w(19)=w(44) + w(71) + w(54) + w(19)
        w(18)=w(18) - 2.D0*w(19)
        w(18)=w(18)*w(1)
        w(18)=w(18) + w(32)
        w(18)=w(18)*w(37)
        w(19)=w(43) + w(15)
        w(32)=w(19)*c0elelqszelc
        w(37)=w(19)*c0celusczel
        w(32)=w(32) - w(37)
        w(43)=w(32) + w(49)
        w(44)=w(50)*jaaqsuselel
        w(43)= - w(44) + 2.D0*w(43)
        w(43)=w(43)*Us
        w(32)=w(32)*w(41)
        w(32)=w(43) - w(32)
        w(32)=w(32)*w(42)
        w(41)=w(19)*w(45)
        w(32)=w(32) + w(41)
        w(32)=w(32)*w(47)
        w(41)=w(50)*b0fuscc
        w(30)=w(30)*w(19)
        w(30)= - w(41) + w(30) + w(61)
        w(37)=w(44) + 2.D0*w(37)
        w(37)=w(37)*Us
        w(30)= - w(37) + 2.D0*w(30)
        w(30)=w(30)*w(1)
        w(19)=w(46)*w(19)
        w(19)=w(30) - w(19)
        w(19)=w(19)*IFI
        w(19)=w(32) - w(19)
        w(30)=2.D0*w(2)
        w(19)=w(19)*w(30)
        w(18)=w(18) + w(19) + w(40)
        w(19)=w(38)*qel
        w(30)= - w(19)*w(79)
        w(32)=w(30)*w(56)
        w(37)=w(19)*d0ccccqstszczc
        w(32)=w(32) + 3.D0*w(37)
        w(32)=w(32)*w(3)
        w(41)=w(37)*pxx2zqsc
        w(27)=w(41)*w(27)
        w(27)=w(32) + w(27)
        w(32)=2.D0*pxx2zqsc
        w(27)=w(27)*w(32)
        w(32)=w(87) + w(17)
        w(32)=w(32)*d0ccccqstszczc
        w(42)=w(68)*w(37)
        w(30)=w(30)*w(3)
        w(43)=w(12) + 1.D0/4.D0
        w(43)=w(43)*w(87)
        w(43)=w(43) + w(12)
        w(44)=w(43)*d0ccccqsuszczc
        w(27)=w(27) - w(32) + 8.D0*w(30) + w(42) + w(44)
        w(27)=w(27)*Ts
        w(19)=w(56)*w(80)*w(19)
        w(30)=w(38)*w(89)*w(78)
        w(14)=w(14) + w(17)
        w(14)=w(14)*c0ccqszcz
        w(14)=w(14) + w(19) + w(30)
        w(19)=w(66) + 1.D0/2.D0
        w(19)=w(19)*w(87)
        w(19)=w(19) + w(66)
        w(30)=w(19)*d0ccccqsuszczc
        w(32)=w(72)*w(84)
        w(38)=w(41)*w(3)
        w(30)=w(32) + w(30) + w(38)
        w(30)=w(30)*pxx2zqsc
        w(32)=w(66) + 3.D0/2.D0
        w(32)=w(32)*w(87)
        w(32)=w(32) + 6.D0*w(12)
        w(32)=w(32)*d0ccccqsuszczc
        w(32)=w(32) - w(37)
        w(32)=w(32)*Us
        w(14)=w(27) + w(32) + w(30) + 2.D0*w(14)
        w(14)=w(14)*w(77)
        w(27)= - b0fqszh + 65.D0*a0fz
        w(27)=11.D0*b0fqscc + 1.D0/6.D0*w(27)
        w(27)=w(27)*w(5)
        w(27)=w(27) - 3.D0/2.D0 + 1.D0/3.D0*w(91) - 29.D0*w(74)
        w(27)=w(27)*w(95)
        w(30)=11.D0/2.D0*w(94)
        w(32)= - w(30) + 16.D0*c0ccqsczc
        w(32)=w(32)*w(5)
        w(32)=w(32) - w(97)
        w(32)=w(32)*w(5)
        w(32)=w(32) + w(55) + c0ccqscwc
        w(32)=w(32)*w(34)
        w(37)=b0fqsww - 1.D0/2.D0
        w(38)=10.D0*a0fz
        w(27)=9.D0*b0fqscc + 7.D0/3.D0*w(37) + 4.D0/3.D0*a0fw + w(38) -
     &   w(62) + w(27) + w(32)
        w(27)=w(27)*w(34)
        w(32)=4.D0*c0ccqsczc
        w(37)= - w(32) + 3.D0*w(94)
        w(41)=w(5)**2
        w(37)=w(37)*w(41)
        w(37)=w(37) + w(67)
        w(37)=w(37)*w(34)
        w(42)=w(74)*w(5)
        w(45)= - 3.D0*w(42) + 4.D0*w(74)
        w(45)=w(45)*w(5)
        w(37)=w(37) + w(45) + 2.D0*w(63)
        w(45)=w(6)*mw**4
        w(37)=w(37)*w(45)
        w(27)=w(27) - w(37)
        w(27)=w(27)*w(6)
        w(17)=w(73) + w(17)
        w(37)=w(17)*c0ccusczc
        w(46)=w(17)*c0ccqszcz
        w(37)=w(37) - w(46)
        w(44)=w(44)*Us
        w(19)=w(19)*w(90)
        w(44)=w(44) - 2.D0*w(37) + 3.D0*w(19)
        w(44)=w(44)*Us
        w(43)=w(43)*w(90)
        w(43)=w(43) + w(46)
        w(43)=w(43)*pxx2zqsc
        w(17)=w(93)*w(17)
        w(17)=w(44) + w(43) + w(17)
        w(17)=w(17)*w(77)
        w(19)=w(37) - w(19)
        w(19)=w(19)*w(52)*w(2)
        w(17)=w(17) - w(19)
        w(17)=w(17)*w(2)
        w(19)=w(69)*w(6)
        w(37)=w(81) + 6.D0*b0fqscc
        w(43)=w(37) + 1.D0
        w(19)= - w(19) + w(43) + w(70)
        w(19)=w(19)*rwz
        w(44)= - 11.D0*w(94) + 23.D0*c0ccqsczc
        w(44)=w(44)*w(5)
        w(44)=w(44) - w(75)
        w(44)=w(44)*w(34)
        w(46)=w(65) + 107.D0/6.D0
        w(46)=1.D0/3.D0*w(46) + 33.D0*w(74)
        w(47)=1.D0/4.D0*w(5)
        w(46)=w(46)*w(47)
        w(32)=w(32)*rwz
        w(30)=w(32) - 10.D0*c0ccqsczc + w(30) - c0ccqscwc
        w(30)=w(30)*Qs
        w(14)=w(27) + w(14) + w(17) - w(44) - w(46) + 15.D0*a0fz + 1.D0/6.
     &   D0*b0fqsww + 33.D0/2.D0*b0fqscc + 3.D0/2.D0*a0fw + w(85) + 103.D0
     &   /36.D0 - PiZgFer - w(30) - w(19) - w(57)
        w(17)=w(15)*c0elelqszelc
        w(17)=w(17) - w(24)
        w(17)= - w(26) + 2.D0*w(17)
        w(19)= - w(17)*w(58)
        w(24)=c0celtsczel*w(35)
        w(24)=w(24) + w(26)
        w(24)=2.D0*w(24) + w(23)
        w(24)=w(3)*w(24)
        w(26)=w(23)*w(64)
        w(17)=w(29) + w(17)
        w(17)=2.D0*w(17) - w(23)
        w(17)=w(17)*w(25)
        w(17)=w(17) + w(26) + w(24) + w(19)
        w(17)=Ts*w(17)
        w(19)= - b0fqszc*w(35)
        w(23)=w(35) + w(22)
        w(23)=b0ftscc*w(23)
        w(24)=w(22)*b0fqscc
        w(19)=w(23) + w(19) - w(24)
        w(19)=w(3)*w(19)
        w(23)= - w(31) - c0elelqszelc
        w(23)=w(35)*w(23)
        w(22)=w(22)*w(6)
        w(24)= - Us*jaaqsuselel*w(22)
        w(19)=w(24) + w(19) - w(29) + w(23)
        w(17)=2.D0*w(19) + w(17)
        w(17)=w(1)*w(17)
        w(19)=w(22)*propizqs
        w(22)= - c0irelelts*w(19)
        w(20)=w(22) - w(20)
        w(20)=Ts*w(20)
        w(19)=c0irelelus*w(19)
        w(19)=w(19) - w(33)
        w(19)=Us*w(19)
        w(15)=w(15)*w(36)
        w(15)= - w(15) + w(19) + w(20)
        w(15)=w(17) + 4.D0*w(15)
        w(15)=IFI*w(15)
        w(17)= - lnlaelm*w(64)
        w(17)=w(17) + 2.D0*c0irelelqs
        w(17)=propizqs*w(17)
        w(19)=1.D0 + 3.D0*w(48)
        w(19)=w(1)*w(6)*w(19)
        w(17)=w(19) + w(17)
        w(19)=w(11) - 1.D0
        w(17)=w(17)*w(39)*w(19)*w(21)
        w(15)=w(15) - w(40) + w(17)
        w(17)=3.D0*c0ccqsczc
        w(19)=w(17) - w(94)
        w(19)=w(5)*w(19)
        w(19)= - 2.D0*c0ccqsczc + w(19)
        w(19)=w(19)*w(51)
        w(20)= - b0fqszh + 47.D0*a0fz
        w(20)=1.D0/12.D0*w(20) + 4.D0*b0fqscc
        w(20)=w(5)*w(20)
        w(19)=w(19) + w(20) + w(92) - 10.D0*b0fqscc - 1.D0 - w(38)
        w(19)=w(5)*w(19)
        w(20)=11.D0 + w(76)
        w(21)= - Za1Bos*w(59)
        w(19)=w(21) - w(62) + 8.D0/3.D0*a0fw + 1.D0/3.D0*w(20) + w(37) +
     &   w(19)
        w(19)=w(34)*w(19)
        w(20)=w(94) - c0ccqsczc
        w(21)= - w(20)*w(41)*w(34)
        w(22)=w(42) - w(74)
        w(22)=w(5)*w(22)
        w(21)=w(21) + w(22) - w(53)
        w(21)=w(21)*w(45)
        w(19)=4.D0*w(21) + w(19)
        w(19)=w(6)*w(19)
        w(21)=w(56)*w(79)*w(12)
        w(22)=w(12)*d0ccccqstszczc
        w(23)= - w(22) + w(21)
        w(21)= - 3.D0*w(22) + w(21)
        w(21)=w(3)*w(21)
        w(24)= - w(22)*w(83)
        w(21)=w(21) + w(24)
        w(21)=pxx2zqsc*w(21)
        w(24)=1.D0/2.D0*w(22)
        w(25)= - w(68)*w(24)
        w(21)=w(25) + 2.D0*w(23) + w(21)
        w(21)=Ts*w(21)
        w(12)= - w(12)*w(88)
        w(22)= - w(28)*w(22)
        w(23)= - c0ccqszcz*w(66)
        w(12)=w(22) + w(23) + w(12)
        w(22)= - w(66)*w(72)
        w(23)= - w(24)*w(86)
        w(22)=w(22) + w(23)
        w(22)=pxx2zqsc*w(22)
        w(23)=d0ccccqsuszczc*w(66)
        w(23)=w(23) + w(24)
        w(23)=Us*w(23)
        w(12)=w(21) + w(23) + 2.D0*w(12) + w(22)
        w(12)=w(12)*w(77)
        w(21)=w(6) - w(9)
        w(21)=rwz*w(53)*w(34)*w(21)
        w(20)=Qs*w(20)
        w(20)=w(21) - w(20)
        w(21)= - Za1Bos - w(57)
        w(21)=w(59)*w(21)
        w(22)= - 10.D0/3.D0 - 1.D0/4.D0*w(65)
        w(22)=1.D0/3.D0*w(22) - w(37)
        w(22)=w(5)*w(22)
        w(17)= - w(17) + 2.D0*w(94)
        w(17)=w(5)*w(17)
        w(17)=c0ccqsczc + w(17)
        w(17)=w(17)*w(51)
        w(12)=w(12) + w(19) - 2.D0*PiZgFer + w(17) + w(22) + w(43) +
     &   w(21) + w(60) + 4.D0*w(20)
        w(11)=PiggFer*w(11)
        w(11)=w(11) - Za1Fer

        ff_qed_ll =  + w(16)
        ff_ew_ll =  + w(13)
        ff_qed_lq =  - w(18)
        ff_ew_lq =  + w(14)
        ff_qed_ql =  - w(18)
        ff_ew_ql =  + w(14)
        ff_qed_qq =  + w(15)
        ff_ew_qq =  + w(12)
        ff_qed_ld =  0d0
        ff_ew_ld =  0d0
        ff_qed_qd =  0d0
        ff_ew_qd =  0d0


        ffarray(1,1) = ff_qed_ll
        ffarray(1,2) = ff_ew_ll
        ffarray(1,3) = ff_qed_lq
        ffarray(1,4) = ff_ew_lq
        ffarray(1,5) = ff_qed_ql
        ffarray(1,6) = ff_ew_ql
        ffarray(1,7) = ff_qed_qq
        ffarray(1,8) = ff_ew_qq
        ffarray(1,9) = ff_qed_ld
        ffarray(1,10) = ff_ew_ld
        ffarray(1,11) = ff_qed_qd
        ffarray(1,12) = ff_ew_qd
        ffarray(1,13) = ff_qed_gg

        return
      end
