!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!> Function to calculate running \f$ \alpha \f$
!! @param alpha0 \f$\alpha(0)\f$
!! @param sq \f$\sqrt{s}\f$
!<-----------------------------------------------------------------------
      real*8 function alphaz (alpha1,sq)
        implicit none!
        include 's2n_declare.h'
        integer i
        real*8 sq,coeff,alpha1
        complex*16 ff_gg

        real*8 za1bo1,zmzzzbo1,zmwzwbo1,zmhzhbo1,deltarhobo1
        real*8 za1fe1,zz1fe1,zh1fe1,zw1fe1,zmsqrfe1,
     &   zmzzzfe1,zmwzwfe1,zmhzhfe1,deltarhofe1,tadfe1
        real*8 caldzfe1,caldwfe1
        complex*16 pizgfe1,piggfe1
        complex*16 pigglep1,za1lep1,piggren1

        common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     &   zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
        common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

        common/unibos_fe1/za1fe1,zz1fe1,zh1fe1,zw1fe1,zmsqrfe1,
     &   zmzzzfe1,zmwzwfe1,zmhzhfe1,deltarhofe1,tadfe1
        common/unipro_fe1/caldzfe1,caldwfe1,pizgfe1,piggfe1

        s = sq**2

        call UniBosConsts_Fe1 ()
        call UniProConsts_fe1 (-s)

        ff_gg =
     &       +stw**2*piggfe1-za1fe1

        coeff = alpha1/4d0/pi/stw2
        ff_gg = coeff*ff_gg
        deltaa = ff_gg

        alphaz = alpha1/(1-deltaa)

        return
      end
