#include "DataSaver.h"
#include "Info.h"
#include "OF_LHEF.h"
#include "OutputFormat.h"
#include "Process.h"

using namespace SANC;

DataSaver::DataSaver(Info &_info, Process &_proc) : info(_info), proc(_proc) {
  if (info.PrintLHE == 1) {
    writer = new OF_LHEF(info, proc);
  }
}

void DataSaver::start(std::string dirName, std::string fileName) {
  if (writer) {
    writer->start(dirName, fileName);
  }
}

void DataSaver::writeEvent() {
  if (writer) {
    writer->writeEvent();
  }
}

void DataSaver::finish() {
  if (writer) {
    writer->finish();
  }
}